set inputs(plus)  2        ; set outputs(plus)  2
set inputs(minus) 2        ; set outputs(minus) 2
set inputs(times) 2        ; set outputs(times) 2
set inputs(quotient) 2     ; set outputs(quotient) 2
set inputs(div) 2          ; set outputs(div) 2
set inputs(mod) 2          ; set outputs(mod) 2
set inputs(power) 2        ; set outputs(power) 2
set inputs(xamodn) 3;      ; set outputs(xamodn) 4

set inputs(cfrac) 2        ; set outputs(cfrac) 1
set inputs(unfrac) 1       ; set outputs(unfrac) 2
set inputs(entuple) 2      ; set outputs(entuple) 1
set inputs(untuple) 1      ; set outputs(untuple) 2
set inputs(enlist) 2       ; set outputs(enlist)  1
set inputs(unlist) 1       ; set outputs(unlist) 2
set inputs(split) 1        ; set outputs(split) 2
set inputs(unsplit) 2      ; set outputs(unsplit) 1

set inputs(cylinder) 1     ; set outputs(cylinder) 1
set inputs(tube) 1         ; set outputs(tube) 1

set inputs(zero) 1         ; set outputs(zero) 2
set inputs(un-zero) 2      ; set outputs(un-zero) 1
set inputs(positive) 1     ; set outputs(positive) 2
set inputs(un-positive) 2  ; set outputs(un-positive) 1

set inputs(toffoli) 3      ; set outputs(toffoli) 3

set inputs(divincenzo) 2   ; set outputs(divincenzo) 2
set inputs(fourier) 2      ; set outputs(fourier) 2
set inputs(not) 1          ; set outputs(not) 1
set inputs(smolin) 2       ; set outputs(smolin) 2
set inputs(deutsch) 3      ; set outputs(deutsch) 3

set inputs(source) 0       ; set outputs(source) 1
set inputs(observe) 1      ; set outputs(observe) 0

set inputs(is_monad) 1     ; set outputs(is_monad) 2
set inputs(un-is_monad) 2  ; set outputs(un-is_monad) 1
set inputs(is_real) 1      ; set outputs(is_real) 2
set inputs(un-is_real) 2   ; set outputs(un-is_real) 1
set inputs(is_complex) 1   ; set outputs(is_complex) 2
set inputs(un-is_complex) 2; set outputs(un-is_complex) 1
set inputs(is_tuple) 1     ; set outputs(is_tuple) 2
set inputs(un-is_tuple) 2  ; set outputs(un-is_tuple) 1
set inputs(is_integer) 1   ; set outputs(is_integer) 2
set inputs(un-is_integer) 2; set outputs(un-is_integer) 1
set inputs(is_list) 1      ; set outputs(is_list) 2
set inputs(un-is_list) 2   ; set outputs(un-is_list) 1
set inputs(is_empty) 1     ; set outputs(is_empty) 2
set inputs(un-is_empty) 2  ; set outputs(un-is_empty) 1


set attribute(divincenzo) phi
set attribute(deutsch) theta
set attribute(smolin) theta
set attribute(source) value
set attribute(observe) "output position"

set attribute_default(divincenzo)  1.0
set attribute_default(deutsch)     1.0
set attribute_default(smolin)      1.0
set attribute_default(source)      0
set attribute_default(observe)     0

proc socket_position {total_count which} {
 switch $total_count {
   1 {if {$which==1} then {return 17}}
   2 {switch $which {
         1 {return 10}
         2 {return 25}
      } 
     }
   3 {switch $which {
         1 {return 6}
         2 {return 17}
         3 {return 29}
       }
      }
     4 {switch $which {
         1 {return 5}
         2 {return 13}
         3 {return 22}
         4 {return 30}
      }
     }
 }
 error "You can't have socket $which out of $total_count"
}