#!/bin/bash

for i in Qgol2/*.lhs
do
  /bin/echo "$i...\c"
  new_name=$(echo $i | sed 's/.lhs$/.ml/' | sed 's/Qgol2/Qgol3/g')

  removed_begin_codes=/tmp/rbc.$$
  echo "(*  Converted from Haskell to CaML ($(date)) " > $removed_begin_codes
  sed 's/\\begin{code}/*)/' $i  | sed 's/\\end{code}/(*/' >> $removed_begin_codes
  echo "*)" >> $removed_begin_codes

  import_to_open=/tmp/ito.$$
  sed 's/^import /open /' $removed_begin_codes > $import_to_open

  cp $import_to_open $new_name
  /bin/echo " converted into $new_name"
done

module_list=/tmp/ml
rm $module_list

cd Qgol3
for i in *.ml
do
  echo "$i:--------" >> $module_list
  grep '^open' $i | sed 's/^open / /' >> $module_list
  echo >> $module_list
done
