(*  Converted from Haskell to CaML (Sun Aug 16 13:05:14 EST 1998) 
\chapter{Qgol2}

This is the main module for the Qgol2 interpreter,  a program which
simulates quantum computations.

\section{Preliminaries}


\section{stringToType}\label{stringToType}
I should find a better place for this function.  Its aim is to find the most
constrained type it can to represent the {\sf String} as the
 (section \ref{Type definition}) program-defined type Type.

I should add in a  \verb+| Recognizenumbers.is_boolean string = Boolean (read string)+

*)
let stringToType str = 
  if (Recognize_numbers.is_integer str) 
      then Qgol_type.Intger (int_of_string str)
  else if (Recognize_numbers.is_real str) 
      then Qgol_type.Dbl (float_of_string str) else Qgol_type.Str str;;

let set_seed () = 
  let seed = Unix.getpid () in
  Random.init seed;
  ()
;;

let main () =
  let argv0::(sourcefile::arguments) = Array.to_list Sys.argv in
  set_seed (); 
  let channel = open_in sourcefile in
  let program = ReadDiagram.readExecutable channel in
  let argv_as_types = List.map stringToType arguments in
  let results = Qfunc.evaluateQfunc program argv_as_types in
  print_endline (Qgol_type.show_list results)
;;

main ();;


