(* this module is a dirty hack to get more results for the same amount
   of work.  It may not work on all platforms *)

let forked_already = ref false;;

let number_of_results = 
 try int_of_string (Sys.getenv "QGOL_NUM_RESULTS")
 with Not_found -> 1;;

let sleep_time = 
 try int_of_string (Sys.getenv "QGOL_SLEEP_TIME")
 with Not_found -> 0;;

let need_to_fork = number_of_results > 1;;

let fork_off () =
  if ((!forked_already) or (not need_to_fork)) then ()
  else 
   (
    forked_already := true; 
    let i = ref 1 in
    while (!i < (number_of_results))
    do
      if (Unix.fork ()=0) 
      then (i := number_of_results; (* I am the child.  Get out of the loop*)
	    Random.init (Unix.getpid ()) (* different random num. seed *)
	      )
      else (  (* start a child,  an exact copy of me *)
	Unix.wait ();
	Unix.sleep sleep_time;
        i := !i + 1;
	);
    done;
   )
;;
